<?php

App::uses('EvSlideshowAppController', 'EvSlideshow.Controller');

/**
 * SlideshowSlides Controller
 *
 */
class SlideshowsController extends EvSlideshowAppController {

	public function admin_edit($id = null) {
		$Model = $this->{$this->modelClass};
		$modelAlias = $Model->alias;

		parent::admin_edit($id);

		$configFields = Configure::read('EvSlideshow.fields');

		foreach ($configFields as $key => $value) {
			if ($key == 'extra') {

				foreach ($value as $extraColumn => &$extraValue) {
					if (isset($extraValue['validate'])) {
						unset($extraValue['validate']);
					}

					$slideFields['extra_' . $extraColumn] = $extraValue;

				}

			} else {
				$slideFields[$key] = $value;
			}
		}
		$this->set('slideFields', $slideFields);

		$this->set('slideSlots', $Model->slideSlots);

		//Get slide image slots so that they can be added to slides
		$this->set('slideImageSlots', $Model->Slide->imageSlots);

		$this->view = 'EvSlideshow./Slideshows/admin_form';
	}

	protected function _adminFormFields() {
		$fields = parent::_adminFormFields();

		if (!$this->Permissions->hasSuperAdminPermission($this->Auth->user())) {
			//Remove the system name field as it can only be set by a super admin and shouldn't be changed
			if (isset($fields['SlideShow.system_name'])) {
				unset($fields['SlideShow.system_name']);
			}

			if (isset($fields['SlideShow.is_protected'])) {
				unset($fields['SlideShow.is_protected']);
			}
		}

		return $fields;
	}
}
